package jalview.gui;

import jalview.datamodel.*;
import jalview.analysis.PCA;
import jalview.jbgui.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class PCAPanel extends GPCAPanel implements Runnable
{
  PCA pca;
  int top;
  RotatableCanvas rc;
  AlignViewport av;

  public void run()
  {
    // do stuff
  }

  public PCAPanel(AlignViewport av, SequenceI[] s) {

    this.av = av;
    if(av.getSelection().size()>3)
    {
      s = new Sequence[av.getSelection().size()];
      for(int i=0; i<s.length; i++)
        s[i] = av.getSelection().sequenceAt(i);
    }


    if(s==null)
    {
      s = new Sequence[av.getAlignment().getHeight()];
      for (int i = 0; i < av.getAlignment().getHeight(); i++)
        s[i] = av.getAlignment().getSequenceAt(i);
     }

//////////////////////This part was done in PCATHread originally. Is it too slow???
    pca = new PCA(s);
    pca.run();

    // Now find the component coordinates
    int ii=0;
    while (ii < s.length && s[ii] != null)
    {
      ii++;
    }

    double[][] comps = new double[ii][ii];

    for (int i=0; i < ii; i++ )
    {
      if (pca.getEigenvalue(i) > 1e-4)
      {
        comps[i]  = pca.component(i);
      }
    }

    //////////////////

    xCombobox.setSelectedIndex(0);
    yCombobox.setSelectedIndex(1);
    zCombobox.setSelectedIndex(2);

    top = pca.getM().rows-1;

    Vector points = new Vector();
    float[][] scores = pca.getComponents(top-1,top-2,top-3,100);

    for (int i =0; i < pca.getM().rows; i++ )
    {
      SequencePoint sp = new SequencePoint(s[i],scores[i]);
      points.addElement(sp);
    }

    rc = new RotatableCanvas(av,points,pca.getM().rows);

    //rc.printPoints();

    add(rc, BorderLayout.CENTER);
  }


  void doDimensionChange()
  {
    if(top==0)
      return;

    int dim1 = top - xCombobox.getSelectedIndex();
    int dim2 = top - yCombobox.getSelectedIndex();
    int dim3 = top - zCombobox.getSelectedIndex();

    float[][] scores  = pca.getComponents(dim1,dim2,dim3,100);
    for (int i=0; i < pca.getM().rows; i++) {
      ((SequencePoint)rc.points.elementAt(i)).coord = scores[i];
    }

    rc.img = null;
    rc.rotmat.setIdentity();
    rc.initAxes();
    rc.paint(rc.getGraphics());
  }

  protected void xCombobox_actionPerformed(ActionEvent e)
  {
    doDimensionChange();
  }

  protected void yCombobox_actionPerformed(ActionEvent e)
  {
    doDimensionChange();
  }

  protected void zCombobox_actionPerformed(ActionEvent e)
  {
    doDimensionChange();
  }

}
